python_tests:
  image: ubuntu:20.04
  stage: test
  services:
    - mysql:latest
  variables:
    MYSQL_DATABASE: python_django_app
    MYSQL_ROOT_PASSWORD: secret
    DEBIAN_FRONTEND: noninteractive
    TZ: Etc/UTC
  cache:
    paths:
      - ~/.cache/pip/
  before_script:
    - cd src/python-django-app
    - apt -y update
    - apt -y install apt-utils
    - apt -y install net-tools python3.8 python3-pip python3-venv pkg-config mysql-client libmysqlclient-dev
    - apt -y upgrade
    - python3 -m venv env
    - source env/bin/activate
    - env/bin/python -V # Print out python version for debugging
    - env/bin/pip install Django mysqlclient
    - env/bin/pip freeze > requirements.txt
    - env/bin/pip install -r requirements.txt
  script:
    # The MYSQL user only gets permissions for MYSQL_DB, so Django can't create a test database.
    - echo "GRANT ALL on *.* to 'root';"| mysql -u root --password="secret" -h mysql
    - env/bin/python manage.py test
